<?php

use WHMCS\Database\Capsule;

function EZ_USDT_MetaData()
{
    return array(
        'DisplayName' => 'EZ USDT支付',
        'APIVersion' => '0.1',
    );
}

function EZ_USDT_config()
{
    $configarray = array(
        "FriendlyName"  => array(
            "Type"  => "System",
            "Value" => "USDT泰达币支付"
        ),
        "address"  => array(
            "FriendlyName" => "USDT收款地址",
            "Type"         => "text",
            "Size"         => "32",
            "Default"         => "",
            "Description"  => "USDT收款，仅可使用TRON地址"
        ),
        "rate" => array(
            "FriendlyName" => "手动汇率",
            "Type"         => "text",
            "Size"         => "32",
            "Description"  => "自动汇率仅支持CNY,JPY,EUR,SGD,RUB和USD，如果你的WHMCS默认货币不在其中，请填写此项，汇率可谷歌“美元对xx汇率”查询"
        ),
        "valid_time" => array(
            "FriendlyName" => "有效时间",
            "Type"         => "text",
            "Default"         => "20",
            "Size"         => "32",
            "Description"  => "每次产生的USDT转账订单的有效期，单位为分钟"
        )
    );

    return $configarray;
}

function EZ_USDT_link($params)
{
    if (@$_REQUEST['getstatus'] == 'yes') {
        return '等待支付中';
    }
    if($_REQUEST['ezusdt'] == 'yes'){
    //检查是否存在表，不存在则创建
    if (!Capsule::schema()->hasTable('EZ_USDT_invoices')) {
        try {
            Capsule::schema()->create("EZ_USDT_invoices", function ($table) {
                $table->increments('id');
                $table->integer('invoice_id');
                $table->integer('quant');
                $table->integer('create_time');
                $table->integer('last_check_time');
                $table->integer('mark');
                $table->enum('status', ['unpaid', 'paid', 'cancelled', 'timeout']);
                $table->string('transaction_id');
            });
        } catch (\Exception $e) {
            return [
                'status'        =>  'error',
                'description'   =>  "无法创建表 'EZ_USDT_invoices' : {$e->getMessage()}"
            ];
        }
    }
    //检查是否存在此发票产生的还处于unpaid的UUSDT账单
    if (!empty(Capsule::table("EZ_USDT_invoices")->where('invoice_id', '=', $params['invoiceid'])->where('status', '=', 'unpaid')->first()->id)) {
        $invoiceid_data_object = Capsule::table("EZ_USDT_invoices")->where('invoice_id', $params['invoiceid'])->where('status', 'unpaid')->first();
        $invoiceid_data = EZ_USDT_object_array($invoiceid_data_object);
        $invoiceid_data['address'] = $params['address'];
        $invoiceid_data['valid_time'] = $params['valid_time'];
        $invoiceid_data['host'] = parse_url($params['systemurl']);
        $invoiceid_data['host'] = $invoiceid_data['host']['host'];
    } else {
        //产生标记值，发票的后三位为USDT的标记词
        $mark = substr($params['invoiceid'], -3);
        //产生一条新的USDT数据并将其存放在EZ_USDT_invoices表中
        $invoiceid_data = array();
        $invoiceid_data['quant'] = (round(($params['amount'] / EZ_USDT_Get_Exchange_Rate($params)), 2) + ($mark / 10000)) * 1000000;
        $invoiceid_data['invoice_id'] = $params['invoiceid'];
        $invoiceid_data['create_time'] = time();
        $invoiceid_data['address'] = $params['address'];
        $invoiceid_data['valid_time'] = $params['valid_time'];
        $invoiceid_data['host'] = parse_url($params['systemurl']);
        $invoiceid_data['host'] = $invoiceid_data['host']['host'];
        Capsule::table("EZ_USDT_invoices")->insert([
            "invoice_id" => $invoiceid_data['invoice_id'],
            "quant" => $invoiceid_data['quant'],
            "create_time" => $invoiceid_data['create_time'],
            "mark" => $mark,
            "status" => 'unpaid'
        ]);
    }
    exit(EZ_USDT_Make_Html($invoiceid_data));
    }
    if (stristr($_SERVER['PHP_SELF'], 'viewinvoice')) {
        return '<form method="post" id=\'ezusdt\'><input type="hidden" name="ezusdt" value="yes"></form><button type="button" class="btn btn-danger btn-block" onclick="document.forms[\'ezusdt\'].submit()">使用USDT支付</button>';
    } else {
        return '<img style="width: 150px" src="' . $params['systemurl'] . '/modules/gateways/EZ_USDT/tether_logo.png" alt="USDT" />';
    }
}


function EZ_USDT_Make_Html($invoiceid_data)
{
        //计算超时的时间
        $EZ_USDT_timeout = $invoiceid_data['create_time'] + ($invoiceid_data['valid_time'] * 60 );
        //$EZ_USDT_timeout = date("Y/m/d H:i:s",$EZ_USDT_timeout);
        //替换模板文件产生新页面
        $skin_raw = file_get_contents(__DIR__ . "/EZ_USDT/themes.tpl");
        $skin_raw = str_replace('EZ_USDT_quant', ($invoiceid_data['quant'] / 1000000), $skin_raw);
        $skin_raw = str_replace('EZ_USDT_address', $invoiceid_data['address'], $skin_raw);
        $skin_raw = str_replace('EZ_USDT_host', $invoiceid_data['host'], $skin_raw);
        $skin_raw = str_replace('EZ_USDT_invoice_id', $invoiceid_data['invoice_id'], $skin_raw);
        $skin_raw = str_replace('EZ_USDT_timeout', $EZ_USDT_timeout * 1000, $skin_raw);
        return $skin_raw;
}



function EZ_USDT_object_array($array) {  
    if(is_object($array)) {  
        $array = (array)$array;  
     } if(is_array($array)) {  
         foreach($array as $key=>$value) {  
             $array[$key] = EZ_USDT_object_array($value);  
             }  
     }  
     return $array;  
}

function EZ_USDT_Get_Exchange_Rate($params) {
	$url = "https://apiv2.bitz.com/Market/currencyCoinRate?coins=usdt";
    $curl = curl_init(); 
    curl_setopt($curl, CURLOPT_URL, $url); 
    if($ssl)
    {
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 1);
        curl_setopt($curl, CURLOPT_SSLVERSION, 3);
    }
    curl_setopt($curl, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']); 
    curl_setopt($curl, CURLOPT_AUTOREFERER, 1); 
    curl_setopt($curl, CURLOPT_TIMEOUT, 30);
    curl_setopt($curl, CURLOPT_HEADER, 0);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    $tmpInfo = curl_exec($curl); 
    if (curl_errno($curl)) {
        var_dump(curl_error($curl));
        return FALSE;
    }
    curl_close($curl);
    $tmpInfo = json_decode($tmpInfo, true);
    $currency = strtolower($params['currency']);
    $rate = $tmpInfo['data']['usdt'][$currency];
    //如果查不到就使用手动设置的汇率
    if (empty($rate)) {
        $rate = $params['rate'];
    }
    return $rate;
}