<?php

if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}


use WHMCS\Database\Capsule;

add_hook("AfterCronJob", 1, function () {
    //从tronscan拉取转账数据
    require_once __DIR__ . '/../../../init.php';
    require_once __DIR__ . '/../../../includes/gatewayfunctions.php';
    $params = getGatewayVariables('EZ_USDT');
    $start_timestamp = (time() - ($params['valid_time'] * 70)) * 1000;
    $url = "https://apiasia.tronscan.io:5566/api/token_trc20/transfers?direction=in&&count=true&tokens=TR7NHqjeKQxGTCi8q8ZY4pL8otSzgjLj6t&start_timestamp=" . $start_timestamp . "&relatedAddress=" . $params['address'];
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url);
    if ($ssl) {
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 1);
        curl_setopt($curl, CURLOPT_SSLVERSION, 3);
    }
    curl_setopt($curl, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
    curl_setopt($curl, CURLOPT_AUTOREFERER, 1);
    curl_setopt($curl, CURLOPT_TIMEOUT, 30);
    curl_setopt($curl, CURLOPT_HEADER, 0);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    $tmpInfo = curl_exec($curl);
    if (curl_errno($curl)) {
        var_dump(curl_error($curl));
        return FALSE;
    }
    curl_close($curl);
    $tmpInfo = json_decode($tmpInfo, true);
    $transfers = $tmpInfo['token_transfers'];
    $now_time = time();
    //对比标准数据以确定哪些账单已经被支付
    foreach ($transfers as $transfer) {
        $create_time = Capsule::table("EZ_USDT_invoices")->where('quant', $transfer['quant'])->where('status', 'unpaid')->first()->create_time;
        $invoice_id = Capsule::table("EZ_USDT_invoices")->where('quant', $transfer['quant'])->where('status', 'unpaid')->first()->invoice_id;
        if (!empty($create_time) && (($create_time * 1000) -  $transfer['block_ts']) < $params['valid_time'] * 80 * 1000) {
            Capsule::table("EZ_USDT_invoices")->where('quant', $transfer['quant'])->where('status', 'unpaid')->update(['transaction_id' => $transfer['transaction_id'], 'status' => 'paid', 'last_check_time' => $now_time]);
            $command = 'UpdateInvoice';
            $postData = array(
                'invoiceid' => $invoice_id,
                'status' => 'Paid',
            );
            localAPI($command, $postData);
        }
    };
    //查看哪些账单已经超时
    $all_EZ_USDT_invoices = Capsule::table("EZ_USDT_invoices")->where('status', 'unpaid')->get();
    $all_EZ_USDT_invoices = json_decode(json_encode($all_EZ_USDT_invoices), true);
    foreach ($all_EZ_USDT_invoices as $all_EZ_USDT_invoice) {
        if ($now_time - $all_EZ_USDT_invoice['create_time'] > $params['valid_time'] * 80) {
            Capsule::table("EZ_USDT_invoices")->where('id', $all_EZ_USDT_invoice['id'])->update(['status' => 'timeout', 'last_check_time' => $now_time]);
        }
    }
});


add_hook('InvoiceCancelled', 1, function ($vars) {
    //标记取消的账单，减小超时检测的负担
    Capsule::table("EZ_USDT_invoices")->where('invoice_id', $vars['invoiceid'])->where('status', 'unpaid')->update(['status' => 'cancelled', 'last_check_time' => time(), 'transaction_id' => 'Cancel invoice']);
});


add_hook('InvoiceChangeGateway', 1, function ($vars) {
    //标记改变支付接口的账单，减小超时检测的负担
    if ($vars['paymentmethod'] != 'EZ_USDT') {
        Capsule::table("EZ_USDT_invoices")->where('invoice_id', $vars['invoiceid'])->where('status', 'unpaid')->update(['status' => 'cancelled', 'last_check_time' => time(), 'transaction_id' => 'Change payment gateway']);
    }
});

add_hook('InvoicePaid', 1, function ($vars) {
    //标记管理员手动确认的账单，减小超时检测的负担
    Capsule::table("EZ_USDT_invoices")->where('invoice_id', $vars['invoiceid'])->where('status', 'unpaid')->update(['status' => 'paid', 'last_check_time' => time(), 'transaction_id' => 'Administrator manual confirmation']);
});
